Subject: Re: [PATCH 3/3] USB: driver for Freescale QUICC Engine USB Host Controller

From: Sergei Shtylyov <[email-masked]>
Date: Wed, 24 Sep 2008 14:48:58 +0400

Hello, I wrote:

>>>>>>> This controller does not integrate the root hub, so this driver 
>>>>>>> also
>>>>>>> fakes one-port hub. External hub is required to support more than
>>>>>>> one device.
>>>>>>>
>>>>>>> ...
>>>>>>>
>>>>>>>                   
>>>>>> Please, no.
>>>>>>               
>>>>> What exactly 'no'? ;-)
>>>>>           
>>>>   No one-port hubs I guess -- they are pointless. Though e.g. MUSB  
>>>> driver creates one -- I guess to impersonate a transaction 
>>>> translating  high-speed hub...
>>>>
>>>>       
>>>   ... then the root hub emulation is completely pointless.
>>>     
>>
>> It isn't. We always should emulate the root hub. The root hub
>> is part and parcel of any USB Host. Even the one-port one.
>
>   Hm, maybe that's what USB core thinks (because UHCI/OHCI/EHCI all 
> have it) but e.g. MUSB doesn't have the root hub registers...

   Oops, I stand corrected. Even USB 1.1 specifies that it must be a 
part the host...

WBR, Sergei